<?php

/**
 *
 * 
 *  @module      	MPForm
 *  @author         Frank Heyne, Dietrich Roland Pehlke (last)
 *  @license        http://www.gnu.org/licenses/gpl.htm
 *  @platform       see info.php of this addon
 *  @license terms  see info.php of this addon
 *  @version        see info.php of this module
 *  
 *
 */

class mpform_recaptcha
{
	//	See: https://developers.google.com/recaptcha/  for Version 2
	//	Domain: https://your_domain.tld
		
	const data_sitekey	= "...";  // Enter your reCAPTCHA_site_key
	const secrect_key	= "...";  // Enter your Google secure-key
	const label_name	= "...";  // Enter your reCAPTCHA_label_name
	
	/**
	 *	Static function that returns the recomented div and script tag for  the google-api
	 *	
	 *	@param	string 	Optional theme; default is 'light'. Possible values are 'light' and 'dark'.
	 *	@param	string 	Optionam size; default is 'normal'. Possible values are 'compact' and 'normal'.
	 *	@return string 	The generated HTML code. 
	 */
	static function build_captcha( $theme="light", $size="normal")
	{
		
		$sTagCode = "   
					<script type='text/javascript'>
						var onloadCallback = function() {
						grecaptcha.render('html_element', {
						'sitekey' : '". self::data_sitekey ."'
						});
					};
					</script>	
		";
		$sTagCode .= "
			<div class='full'>
				<label for='". self::label_name ."'><span>Anti-Spam</span>
					<div id='html_element'></div>
				</label>
			</div>	
		";			
		$sTagCode .= "
			<script src='https://www.google.com/recaptcha/api.js?onload=onloadCallback&render=explicit'
				async defer>
			</script>
		";			
		
		return $sTagCode;
	}
	
	/**
	 *	Test the resposnse value agains the google-api
	 *
	 *	@param	string 	The resonse from the captcha to test.
	 *	@return Array	Assoc. array with the test-result from the google-api
	 */
	static function test_captcha( $theResponse )
	{
		$url = "https://www.google.com/recaptcha/api/siteverify";
		
		$fields = array(
			'secret'	=> self::secrect_key,
			'response'	=> $theResponse,
			'remoteip'	=> $_SERVER['REMOTE_ADDR']
		);
	
		$options = array(
			CURLOPT_URL => $url, 
			CURLOPT_POST => true,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_POSTFIELDS => $fields
		);
	
		$ch = curl_init( $url );
	
		curl_setopt_array( $ch, $options );
	
			
		$result = curl_exec ($ch); 
    	curl_close($ch); 
	
		$info = json_decode( $result, true ); 
		
		return $info;
	}
}

?>